function EndCurve(~)
 set(0,'defaultaxesfontsize',30,'defaulttextinterpreter','latex');
    gamma = 9.6511;
    lambda = 0.0;
    nu = 0.0;
    X0 = 0.1;
    options = odeset('AbsTol',1e-5,'RelTol',1e-4);
    k=1
    for beta = 0.000000001:0.05:20;
        R_0(k) = beta/gamma;
        [t x]=ode45(@SISModel,[0 100],X0,options);
        IIh(k) = x(max(size(x)));
        if R_0(k) > 1
            RR(k) = R_0(k);
            DFEIh(k) = 0;
        end
    k=k+1
    end

    figure, hold on
    plot(R_0,IIh,'b','LineWidth',3)
    plot(RR(find(R_0>=1)), DFEIh(find(R_0>=1)),'r--','LineWidth',3)
    axis([0,2,0,0.5])
    xlabel('Basic reproduction number, $R_0$')
    ylabel('Infectious proportion, $I$')
    legend('Stable equilibrium','unstable equilibrium')
    box
    
    function dIdt = SISModel(t,I)
    dIdt = beta*(1-I)*I - (lambda+gamma+nu)*I +nu*I*I;
    end
end
    