%% The results should be compared to the PRCC results section in
clear all;
close all;
clc;
set(0,'defaulttextinterpreter','Latex');
%%%%%%%%%%%%%%%%%%%%%%%%%%% Sample size N %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
runs = 100;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% LHS MATRIX  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Params_Ih;

 beta0_LHS = LHS_Call(0.1*beta0, beta0, 1.9*beta0, 0 ,runs,'unif');
 beta1_LHS = LHS_Call(0.1*beta1, beta1, 1.9*beta1, 0 ,runs,'unif');
 gamma0_LHS = LHS_Call(0.1*gamma0, gamma0, 1.9*gamma0, 0 ,runs,'unif');
 gamma1_LHS = LHS_Call(0.1*gamma1, gamma1, 1.9*gamma1, 0 ,runs,'unif');
 rc_LHS = LHS_Call(0.1, rc, 0.5, 0 ,runs,'unif');
 delta_LHS = LHS_Call(0.1, delta, 0.5, 0 ,runs,'unif');
 alpha_LHS = LHS_Call(0.2, alpha, 0.8, 0 ,runs,'unif');
 n_LHS = LHS_Call(1, n, 10, 0 ,runs,'unif');
 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%% LHS MATRIX and PARAMETER LABELS %%%%%%%%%%%%%%%%%%%%%%
LHSmatrix = [beta0_LHS beta1_LHS gamma0_LHS gamma1_LHS rc_LHS delta_LHS alpha_LHS n_LHS];
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%% Solve ODE with parameters from LHS matrix %%%%%%%%%%%%%%%%%
%options = odeset('RelTol',1e-9,'AbsTol',1e-8); 
for x = 1:runs %Run solution x times choosing different values
    f = @DisEcons_LHS_Ih;
    x
    LHSmatrix(x,:);
    [t,z]=ode45(@(t,y)f(t,y,LHSmatrix,x,runs),tspan,y0,[]); 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%    
% Save outputs only at time points of interest [time_points]: MORE EFFICIENT
    t_lhs(:,x)=t(time_point+1,1);
    I_lhs(:,x)=z(time_point+1,1);
    h_lhs(:,x)=z(time_point+1,2);
    y_lhs(:,x)=h_lhs(:,x).^(alpha);
%
end
%%%%%%%%%%%%%%%%%%%%%%%%%% Save the workspace %%%%%%%%%%%%%%%%%%%%%%%%%%%%%
save DisEcons_LHS_Main.mat;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%% CALCULATE PRCC %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% 99% confidence interval
%
[prcc_i sign_i sign_label1] = PRCC(LHSmatrix,I_lhs,1:length(time_point),PRCC_var,0.01)
[prcc_y sign_y sign_label2] = PRCC(LHSmatrix,y_lhs,1:length(time_point),PRCC_var,0.01)
[prcc_h sign_h sign_label_h] = PRCC(LHSmatrix,h_lhs,1:length(time_point),PRCC_var,0.01)