%% The results should be compared to the PRCC results section in
%% Supplementary Material D and Table D.1 for different N (specified by
%% "runs" in the script below
clear all;
close all;
clc;
set(0,'defaulttextinterpreter','Latex');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%% Sample size N %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
runs = 100;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% LHS MATRIX  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Params_Iy;

%  beta0_LHS = LHS_Call(0.67*beta0, beta0, 1.33*beta0, 0 ,runs,'unif'); % baseline = 9e-5;
%  beta1_LHS = LHS_Call(0.67*beta1, beta1, 1.33*beta1, 0 ,runs,'unif'); % baseline = 5e-5;
%  gamma0_LHS = LHS_Call(0.67*gamma0, gamma0, 1.33*gamma0, 0 ,runs,'unif'); % baseline = 3e-7;
%  gamma1_LHS = LHS_Call(0.67*gamma1, gamma1, 1.33*gamma1, 0 ,runs,'unif'); % baseline = 1.2;
%  rc_LHS = LHS_Call(0.67*rc, rc, 1.33*rc, 0 ,runs,'unif'); % baseline = 0.6;
%  delta_LHS = LHS_Call(0.67*delta, delta, 1.33*delta, 0 ,runs,'unif'); % baseline = 0.6;
%  alpha_LHS = LHS_Call(0.67*alpha, alpha, 1.33*alpha, 0 ,runs,'unif'); % baseline = 20e-5;
%  n_LHS = LHS_Call(1, n, 10, 0 ,runs,'unif'); % baseline = 4.8e-2;
 
 
 beta0_LHS = LHS_Call(0.1*beta0, beta0, 1.9*beta0, 0 ,runs,'unif');
 beta1_LHS = LHS_Call(0.1*beta1, beta1, 1.9*beta1, 0 ,runs,'unif');
 gamma0_LHS = LHS_Call(0.1*gamma0, gamma0, 1.9*gamma0, 0 ,runs,'unif');
 gamma1_LHS = LHS_Call(0.1*gamma1, gamma1, 1.9*gamma1, 0 ,runs,'unif');
 rc_LHS = LHS_Call(0.1, rc, 0.5, 0 ,runs,'unif');
 delta_LHS = LHS_Call(0.1, delta, 0.5, 0 ,runs,'unif');
 alpha_LHS = LHS_Call(0.2, alpha, 0.8, 0 ,runs,'unif');
 n_LHS = LHS_Call(1, n, 20, 0 ,runs,'unif');
 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%% LHS MATRIX and PARAMETER LABELS %%%%%%%%%%%%%%%%%%%%%%
LHSmatrix = [beta0_LHS beta1_LHS gamma0_LHS gamma1_LHS rc_LHS delta_LHS alpha_LHS n_LHS];
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%% Solve ODE with parameters from LHS matrix %%%%%%%%%%%%%%%%%
%options = odeset('RelTol',1e-9,'AbsTol',1e-8); 
for x = 1:runs %Run solution x times choosing different values
    f = @DisEcons_LHS_Iy;
    x
    LHSmatrix(x,:);
    [t,z]=ode45(@(t,y)f(t,y,LHSmatrix,x,runs),tspan,y0,[]); 
   % A=[t y]; % [time y]
    %%%%%%%%%%% Save the outputs at ALL time points [tspan] %%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%    
% Save outputs only at time points of interest [time_points]: MORE EFFICIENT
    t_lhs(:,x)=t(time_point+1,1);
    I_lhs(:,x)=z(time_point+1,1);
    y_lhs(:,x)=z(time_point+1,2);
    h_lhs(:,x)=y_lhs(:,x).^(1/alpha);
%
%     Dyn_I_lhs(:,x)=A(time_points+1,2);
%     Dyn_y_lhs(:,x)=A(time_point+1,3);
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%% Save the workspace %%%%%%%%%%%%%%%%%%%%%%%%%%%%%
save DisEcons_LHS_Main.mat;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%% CALCULATE PRCC %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% 99% confidence interval
%
[prcc_i sign_i sign_label1] = PRCC(LHSmatrix,I_lhs,1:length(time_point),PRCC_var,0.01)
[prcc_y sign_y sign_label2] = PRCC(LHSmatrix,y_lhs,1:length(time_point),PRCC_var,0.01)
[prcc_h sign_h sign_label_h] = PRCC(LHSmatrix,h_lhs,1:length(time_point),PRCC_var,0.01)
%
%[prcc_i sign_i sign_label1] = PRCC(LHSmatrix,Dyni_lhs,1:length(time_points),PRCC_var,0.01)
%[prcc_h sign_h sign_label2] = PRCC(LHSmatrix,Dynh_lhs,1:length(time_points),PRCC_var,0.01)
%
% 95 % confidence interval
%
%[prcc_i sign_i sign_label1] = PRCC(LHSmatrix,i_lhs,1:length(time_points),PRCC_var,0.05)
%[prcc_h sign_h sign_label2] = PRCC(LHSmatrix,h_lhs,1:length(time_points),PRCC_var,0.05)
%
%RCC_PLOT(LHSmatrix,CD4_lhs,1,'lin',PRCC_var,y_var_label(2))

 %%PRCC_PLOT(LHSmatrix,i_lhs,1,PRCC_var,y_var_label(1))
 %%PRCC_PLOT(LHSmatrix,h_lhs,1,PRCC_var,y_var_label(2))
% PRCC_PLOT(LHSmatrix,V_lhs,1,PRCC_var,y_var_label(5))

%ranking(LHSmatrix); 

%PRCC_PLOT(LHSmatrix,Dyn_I_lhs,1,PRCC_var,y_var_label(1))
% [Dynprcc_I Dynsign_I Dynsign_label_I] = DynPRCC(LHSmatrix,Dyn_I_lhs,1:length(time_points),PRCC_var,0.01);
% %
% set(0,'DefaultAxesFontName', 'Times New Roman','defaultaxesfontsize',30,'defaulttextinterpreter','latex');
% %
% figure
% plot(time_points,Dynprcc_I,'LineWidth',3)
% xlabel('time, $t$')
% ylabel('PRCCs')
% legend('$\beta_0$', '$\beta_1$', '$\gamma_0$', '$\gamma_1$', '$r_c$', '$\delta$', '$\alpha$', '$n$')
% % figure,hold all
% plot(time_points,Dynamic_prcc_Ih(:,2),'LineWidth',3)
% plot(time_points,Dynamic_prcc_Ih(:,4),'LineWidth',3)
% plot(time_points,Dynamic_prcc_Ih(:,8),'LineWidth',3)
% plot(time_points,Dynamic_prcc_Ih(:,10),'LineWidth',3)
% plot(time_points,Dynamic_prcc_Ih(:,11),'LineWidth',3)
% plot(time_points,Dynamic_prcc_Ih(:,12),'LineWidth',3)
% plot(time_points,Dynamic_prcc_Ih(:,13),'LineWidth',3)
% plot(time_points,Dynamic_prcc_Ih(:,15),'LineWidth',3)
% plot(time_points,Dynamic_prcc_Ih(:,16),'LineWidth',3)
% plot(time_points,Dynamic_prcc_Ih(:,17),'LineWidth',3)
% plot(time_points,Dynamic_prcc_Ih(:,18),'LineWidth',3)
% hold off
% xlabel('time in days')
% ylabel('PRCCs')
% legend('$\gamma_h$','$\nu_h$','$b$','$\beta_{max}$','$p_{hv}$','$p_{vh}$','$\alpha$','$\Lambda_v$','$\nu_v$','$\mu_{v0}$','$\mu_{v1}$')
% figure,hold all
% plot(time_points,Dynamic_prcc_Ih(:,1),'LineWidth',2)
% plot(time_points,Dynamic_prcc_Ih(:,3),'LineWidth',2)
% plot(time_points,Dynamic_prcc_Ih(:,5),'LineWidth',2)
% plot(time_points,Dynamic_prcc_Ih(:,6),'LineWidth',2)
% plot(time_points,Dynamic_prcc_Ih(:,7),'LineWidth',2)
% plot(time_points,Dynamic_prcc_Ih(:,9),'LineWidth',2)
% %plot(time_points,Dynamic_prcc_Ih(:,11),'LineWidth',2)
% %plot(time_points,Dynamic_prcc_Ih(:,13),'LineWidth',2)
% plot(time_points,Dynamic_prcc_Ih(:,14),'LineWidth',2)
% hold off
% xlabel('time in days')
% ylabel('PRCCs')
% legend('$\Lambda_h$','$\delta_h$','$\mu_h$','$\rho_h$','$\sigma_{h}$','$\beta_{min}$','$\theta$')